
#   DefineRegister Analyser aVME Energy		        "-a $A16Base -o 0x88 -w 16 -d 16 -p rw -q k -t eV -n 3 -r 0:0eV,0xffff:416667eV -i 0eV"
#                         Analyser.Power                : -a0x00008000 -o0x0000008a -w16 -d8 -ud -mn -prw -l1 -b0 -i0 -zd -s0
#   DefineRegister Analyser xvme560 Volts+		"-a$A16Base -c1 -g1 -qk -uV -d2 -r0:0V,0xfff:25kV"
#   DefineRegister Analyser xvme560 Volts-		"-a$A16Base -c2 -g1 -qk -uV -d2 -r0:0V,0xfff:25kV"
#   DefineRegister Analyser xvme560 Current+          	"-a$A16Base -c3 -g1 -qu -uA -d0 -r0:0A,0xfff:1mA"
#   DefineRegister Analyser xvme560 Current-	        "-a$A16Base -c4 -g1 -qu -uA -d0 -r0:0A,0xfff:1mA"

#   DefineRegister Detector xvme560 Volts		"-a$A16Base -c5 -g0 -q  -uV -d0 -r0:0V,0xfff:3.5kV"
#   DefineRegister Detector xvme560 Current		"-a$A16Base -c6 -g0 -qu -uA -d0 -r0:0A,0xfff:1mA"

#   DefineRegister Integrator xvme560 Current             "-a$A16Base -c7 -g0"
#   DefineRegister Integrator dose Dose		          "-a [expr $A16Base+0x88]"
#   DefineRegister Integrator dosestep Dose.Step	  "-a [expr $A16Base+0x8b] -d 8 -b 1 -l 6"
#   DefineRegister Integrator pps PPS		          "-a [expr $A16Base+0x8b] -d 8 -b 1 -l 2"
#   DefineRegister Integrator fullscale Current.Range     "-a [expr $A16Base+0x8b] -d 8 -b 3 -l 4"
#   DefineRegister Integrator percent Percent	          "-a [expr $A16Base+0x8c]"

#Detector.Angle.Scan.Window    : -n=MeisRegs -a=0x00000003 -w=32 -p=rw -q=  -u=% -d=0 -r=0x00000000:0 %,0x000003e8:100 % -i=25 %
#Detector.Current              : -a=0x00009000 -c6 -g=0 -q=u -u=A -d=0 -r=0x0000:0uA,0x0fff:1000uA
#Detector.Current.Request      : -a0x0000a000 -o0x00000002 -w16 -d16 -ud -mn -pwo -qu -tA -n0 -r0x0:0uA,0xfff:1000uA -i0uA
#Detector.Energy.Scan.Window   : -n=MeisRegs -a=0x00000004 -w=32 -p=rw -q=  -u=% -d=0 -r=0x00000000:0 %,0x000003e8:100 % -i=25 %
#Detector.Scan.Channel         : -n=MeisRegs -a=0x00000006 -w=32 -p=rw -l=0 -b=0 -f=d -i=0
#Detector.Scan.Spectrum        : -n=MeisRegs -a=0x00000005 -w=32 -p=rw -l=0 -b=0 -f=d -i=0
#Detector.Volts                : -a=0x00009000 -c5 -g=0 -q=  -u=V -d=0 -r=0x0000:0 V,0x0fff:3500 V
#Detector.Volts.Request        : -a0x0000a000 -o0x00000000 -w16 -d16 -ud -mn -pwo -q  -tV -n0 -r0x0:0 V,0xfff:3500 V -i0 V


#xvme560   0x9000
#xvme240   0x8000
#msda12    0xa000

    variable doseStep
    set doseStep {
	"0 C"    "0 C"    "0 C"    "0 C"
	"20 mC"  "2 mC"   "200 uC" "20 uC"
	"6 mC"   "600 uC" "60 uC"  "6 uC"
	"2 mC"   "200 uC" "20 uC"  "2 uC"
	"600 uC" "60 uC"  "6 uC"   "600 nC"
	"200 uC" "20 uC"  "2 uC"   "200 nC"
	"60 uC"  "6 uC"   "600 nC" "60 nC"
	"20 uC"  "2 uC"   "200 nC" "20 nC"
	"6 uC"   "600 nC" "60 nC"  "6 nC"
	"2 uC"   "200 nC" "20 nC"  "2 nC"
	"600 nC" "60 nC"  "6 nC"   "600 pC"
	"200 nC" "20 nC"  "2 nC"   "200 pC"
	"60 nC"  "6 nC"   "600 pC" "60 pC"
	"20 nC"  "2 nC"   "200 pC" "20 pC"
	"6 nC"   "600 pC" "60 pC"  "6 pC"
	"2 nC"   "200 pC" "20 pC"  "2 pC"}

# typedef struct conversion_constants {
#     double m;
#     UCHAR  decimals;                  /* number of decimal places             */
#     char   prefix;                    /* SI prefix                            */
# } CONV;

     variable dose
     set dose {
	{0     0  "m"} {0     0  "m"} {0     0  "m"} {0     0  "m"}
	{0.02  2  " "} {2     0  "m"} {0.2   1  "m"} {0.02  2  "m"}
	{6     0  "m"} {0.6   1  "m"} {0.06  2  "m"} {6     0  "u"}
	{2     0  "m"} {0.2   1  "m"} {0.02  2  "m"} {2     0  "u"}
	{0.6   1  "m"} {0.06  2  "m"} {6     0  "u"} {0.6   1  "u"}
	{0.2   1  "m"} {0.02  2  "m"} {2     0  "u"} {0.2   1  "u"}
	{0.06  2  "m"} {6     0  "u"} {0.6   1  "u"} {0.06  2  "u"}
	{0.02  2  "m"} {2     0  "u"} {0.2   1  "u"} {0.02  2  "u"}
	{6     0  "u"} {0.6   1  "u"} {0.06  2  "u"} {6     0  "n"}
	{2     0  "u"} {0.2   1  "u"} {0.02  2  "u"} {2     0  "n"}
	{0.6   1  "u"} {0.06  2  "u"} {6     0  "n"} {0.6   1  "n"}
	{0.2   1  "u"} {0.02  2  "u"} {2     0  "n"} {0.2   1  "n"}
	{0.06  2  "u"} {6     0  "n"} {0.6   1  "n"} {0.06  2  "n"}
	{0.02  2  "u"} {2     0  "n"} {0.2   1  "n"} {0.02  2  "n"}
	{6     0  "n"} {0.6   1  "n"} {0.06  2  "n"} {6     0  "p"}
	{2     0  "n"} {0.2   1  "n"} {0.02  2  "n"} {2     0  "p"} }

    variable QUAL
    set QUAL {
        {a  1.0e-18}                                                ;#  /* ato   */
        {f  1.0e-15}                                                ;#   /* femto */
        {p  1.0e-12}                                                ;#  /* pico  */
        {n  1.0e-9 }                                               ;#   /* nano  */
        {u  1.0e-6 }                                                ;#  /* micro */
        {m  1.0e-3 }                                              ;#    /* milli */
        {c  0.01   }                                            ;#       /* centi */
        {d  0.1    }                                                ;#  /* deci  */
        {D  10.0   }                                              ;#    /* deca  */
        {h  100.0  }                                               ;#   /* hecto */
        {K  1.0e3  }                                                ;#   /* kilo  */
        {k  1.0e3  }                                                ;#   /* kilo  */
        {M  1.0e6  }                                                ;#   /* mega  */
        {G  1.0e9  }                                                 ;#  /* giga  */
        {T  1.0e12 }                                                ;#   /* tera  */
        {P  1.0e15 }                                             ;#     /* peta  */
        {E  1.0e18 }                                               ;#    /* exa   */
        {*  1.0  }}                                                ;#   /* default  */

    variable ppsRange
    set ppsRange [list 1 10 100 1000]

    variable fullscaleRange
    set fullscaleRange [list 0 20mA 6mA 2mA 600uA 200uA 60uA 20uA 2uA 600na 200nA 60nA 20nA 6nA 2nA]


    proc stor str {      ;#   string str to real conversion     ie  1.2 mV => 0.0012
       variable QUAL

#puts "stor: $str"
        scan $str "%f%n" value n
        set q [string range $str $n $n]    ;# extract the qualifier
        set vl $value
        foreach item $QUAL {
           if {[first $item] == $q} {set vl [expr $value * [second $item]]; break}
        }
#puts "stor: $item value=$vl"
        return $vl
    }


    proc rtos {value q u} {          ;#  real value to string conversion   ie 0.0012 => 1.2mV
        variable QUAL

        foreach item $QUAL {
           if {[first $item] == $q} {set value [expr $value / [second $item]]}
        }
        if {$q == "*"} {
            set vl [format "%.3f%s" [expr 1.0 * $value] $u]
        } else {
            set vl [format "%.3f%s%s" [expr 1.0 * $value] $q $u]
        }
#puts "rtos: value $q $u => $vl"
        return $vl
    }

    proc dtoa {value M C} {       ;#  digital to analogue conversion    y = (m * x) + c
#puts "dtoa: $value $M $C"
       return [expr ($M * $value) + $C]
    }

    proc atod {value M C} {       ;#  analogue to digital conversion    x = (y - c) / m
#puts "atod: $value $M $C"
      set vl [expr round(($value - $C) / $M)]
      return $vl
    }

    proc bcdtos {x} {

      set vl [expr ($x & 15) + ((($x >> 4) & 15) * 10) + ((($x >> 8) & 15) * 100) + ((($x >> 12) & 15) * 1000)]
      return $x    ;#  in Tcl numbers are bcd by default
    }

    proc stobcd {x} {

      set vl [expr ($x & 15) + ((($x >> 4) & 15) * 10) + ((($x >> 8) & 15) * 100) + ((($x >> 12) & 15) * 1000)]
      return $x    ;#  in Tcl numbers are bcd by default
    }

    proc ReadMEISDataRegister {} {
        while {[ReadVMERegister xvme560#1.Busy] == 1} {sleep 10}
        return [ReadVMERegister xvme560#1.Data]
   }

    proc ReadMEISRegister {reg}  {
        variable doseStep
        variable dose
        variable ppsRange
        variable fullscaleRange

        set rc 0xdead

        switch $reg {
           Analyser.Volts+  {    ;#    0:0V,0xfff:25kV

              set rMin 0.0
              set rMax 25000.0
              set Dmin 0
              set Dmax 0xfff
              set M [expr ($rMax - $rMin) / ($Dmax - $Dmin)]
              set C [expr $rMin - ($M * $Dmin)]

               WriteVMERegister xvme560#1.Gain 1
               WriteVMERegister xvme560#1.Channel 1
               set vl [ReadMEISDataRegister]
               set rc [rtos [dtoa $vl $M $C] k V]
           }
           Analyser.Volts-  {   ;#    0:0V,0xfff:25kV

              set rMin 0.0
              set rMax 25000.0
              set Dmin 0
              set Dmax 0xfff
              set M [expr ($rMax - $rMin) / ($Dmax - $Dmin)]
              set C [expr $rMin - ($M * $Dmin)]

               WriteVMERegister xvme560#1.Gain 1
               WriteVMERegister xvme560#1.Channel 2
               set vl [ReadMEISDataRegister]
               set rc [rtos [dtoa $vl $M $C] k V]
           }
           Analyser.Current+  {     ;#   0:0A,0xfff:1mA

              set rMin 0.0
              set rMax 1000.0
              set Dmin 0
              set Dmax 0xfff
              set M [expr ($rMax - $rMin) / ($Dmax - $Dmin)]
              set C [expr $rMin - ($M * $Dmin)]

               WriteVMERegister xvme560#1.Gain 1
               WriteVMERegister xvme560#1.Channel 3
               set vl [ReadMEISDataRegister]
               set rc [rtos [dtoa $vl $M $C] u A]
           }
           Analyser.Current-  {     ;#   0:0A,0xfff:1mA

              set rMin 0.0
              set rMax 1000.0
              set Dmin 0
              set Dmax 0xfff
              set M [expr ($rMax - $rMin) / ($Dmax - $Dmin)]
              set C [expr $rMin - ($M * $Dmin)]

               WriteVMERegister xvme560#1.Gain 1
               WriteVMERegister xvme560#1.Channel 4
               set vl [ReadMEISDataRegister]
               set rc [rtos [dtoa $vl $M $C] u A]
           }
           Analyser.Energy  {
              set rc [ReadVMERegister Analyser.Energy]   ;# xvme560
           }
           Analyser.Power  {
               set rc [ReadVMERegister Analyser.Power]   ;# xvme560
           }
           Detector.Volts  {          ;# 0:0V,0xfff:3.5kV

              set rMin 0.0
              set rMax 3500.0
              set Dmin 0
              set Dmax 0xfff
              set M [expr ($rMax - $rMin) / ($Dmax - $Dmin)]
              set C [expr $rMin - ($M * $Dmin)]

               WriteVMERegister xvme560#1.Gain 0
               WriteVMERegister xvme560#1.Channel 5
               set vl [ReadMEISDataRegister]
               set rc [rtos [dtoa $vl $M $C] * V]
           }
           Detector.Current  {        ;#  0:0A,0xfff:1mA

              set rMin 0.0
              set rMax 3500.0
              set Dmin 0
              set Dmax 0xfff
              set M [expr ($rMax - $rMin) / ($Dmax - $Dmin)]
              set C [expr $rMin - ($M * $Dmin)]

               WriteVMERegister xvme560#1.Gain 0
               WriteVMERegister xvme560#1.Channel 6
               set vl [ReadMEISDataRegister]
               set rc [rtos [dtoa $vl $M $C] u A]
           }
           Detector.Volts.Request  {
               set rc [ReadVMERegister Detector.Volts.Request]    ;#  msda12
           }
           Detector.Current.Request  {
               set rc [ReadVMERegister Detector.Current.Request]  ;#  msda12
           }
           Integrator.Current  {
               WriteVMERegister xvme560#1.Gain 0
               WriteVMERegister xvme560#1.Channel 7
               set rc [format "0x%03x" [ReadMEISDataRegister]]
           }
           Integrator.Dose  {
               set x [ReadVMERegister Integrator.Preset]                          ;#  xvme240
               set i [expr ([ReadVMERegister Integrator.Range] >> 1) & 63]        ;#  xvme240
               set conv [lindex $dose $i]
               set x [bcdtos $x]
               if {$x > 9999} {set x 9999}
               set value [expr 1.0 * [first $conv] * $x]
               set rc [set value][third $conv]C
           }
           Integrator.Dose.Step  {    ;#  Note - Dose Step is a read only register
               set i [expr [ReadVMERegister Integrator.Dose.Step] & 63]     ;#  xvme240
               set rc [lindex $doseStep $i]
           }
           Integrator.Current.Range  {      ;#  Note class fullscale - this is a read only register
               set i [expr [ReadVMERegister Integrator.Current.Range] & 15]  ;#  xvme240
               set rc [lindex $fullscaleRange $i]
           }
           Integrator.PPS  {   ;#  Note - PPS is a read only register
               set i [expr [ReadVMERegister Integrator.PPS] & 3]         ;#  xvme240
               set rc [lindex $ppsRange $i]
           }
           Integrator.Percent  {    ;#  Note Percent is a read only register
               set readout [bcdtos [ReadVMERegister Integrator.Readout]]      ;#  xvme240
               set preset [bcdtos [ReadVMERegister Integrator.Preset]]        ;#  xvme240
               if {$readout >= $preset} {set percent 100} else {set percent [expr ($readout * 100) / $preset]}
               set rc [format "%d %%" $percent]
           }
           Integrator.Start  {
               set z [catch {ReadVMERegister Integrator.Start} rc]    ;#  xvme240
           }
           Integrator.Stop  {
               set rc [ReadVMERegister Integrator.Stop]    ;#  xvme240
           }
           Integrator.Running  {
               set z [catch {ReadVMERegister Integrator.Running} rc]    ;#  xvme240
           }
           MEIS.Go {
               set z [catch {ReadNETRegister MEIS.GO} rc]
           }

           default  {InsertLog "ReadMEISRegister:  unknown register $reg"}
        }

        return $rc
    }

    proc WriteMEISRegister {reg vl}  {

        set rc 0xdead

        switch $reg {
           Integrator.Start  {
               set z [catch {WriteVMERegister Integrator.Start 0} rc]   ;#  xvme240
           }
           Integrator.Stop  {
               set rc [WriteVMERegister Integrator.Stop 0]              ;#  xvme240
           }
           Integrator.Dose  {
               set i [expr ([ReadVMERegister Integrator.Range] >> 1) & 63]    ;#  xvme240
               set conv [lindex $dose $i]
               set x [stobcd $vl]
               set rc [WriteVMERegister Integrator.Preset $x]
               set rc [ReadVMERegister Integrator.Load 1]     ;# twiddle load bit 
               set rc [ReadVMERegister Integrator.Load 0]
               set rc 0
           }
           Detector.Volts.Request  {
               set rc [WriteVMERegister Detector.Volts.Request $vl]    ;#  msda12
           }
           Detector.Current.Request  {
               set rc [WriteVMERegister Detector.Current.Request $vl]  ;#  msda12
           }
           Analyser.Power  {
               set rc [WriteVMERegister Analyser.Power $vl]      ;#  xvme240
           }
           Analyser.Energy  {
               set rc [WriteVMERegister Analyser.Energy $vl]     ;#  xvme240
           }
           MEIS.Go {
               set z [catch {WriteNETRegister MEIS.Go $vl} rc]
           }
           default  {InsertLog "WriteMEISRegister:  unknown register $reg"}
        }

        return $rc
    }




