

variable AcqSetOption "undefined"
variable AcqGetOption "undefined"
variable AcqParameter "undefined"


    proc DAQ_DoOption {option} {
        global errorCode errorInfo
        global DataAcquisitionControlServerHost
        variable AcqSetOption
        global MIDAS_DataAcquisitionControlServer_Exists

        set AcqSetOption $option

       if {[info exists MIDAS_DataAcquisitionControlServer_Exists] && $MIDAS_DataAcquisitionControlServer_Exists == 1} {

          set rc [catch {interp eval "" ::namespace inscope ::urn:DataAcquisitionControlServer DoOption "$AcqSetOption"} m]
       } else {

           if {$DataAcquisitionControlServerHost != $::DataAcquisition::ACQSERVER} {
                set DataAcquisitionControlServerHost  $::DataAcquisition::ACQSERVER
                DataAcquisitionControlClient_Configure
           }
           set rc [catch {DataAcquisitionControlClient__DoOption "$AcqSetOption"} m]
      }

        if {$rc != 0} {
            InsertLog "DO OPTION returned with an error\n$m\n$errorCode\n$errorInfo"
            set rc -1
        } else {
#            InsertLog "DO OPTION returned $m"
             set rc [second $m]
        }

        return $rc

     }

    proc DAQ_GetOption {option} {
        global errorCode errorInfo
        global DataAcquisitionControlServerHost
        variable AcqGetOption
        global MIDAS_DataAcquisitionControlServer_Exists

        set AcqGetOption $option

       if {[info exists MIDAS_DataAcquisitionControlServer_Exists] && $MIDAS_DataAcquisitionControlServer_Exists == 1} {

          set rc [catch {interp eval "" ::namespace inscope ::urn:DataAcquisitionControlServer GetOption "$AcqGetOption"} m]
       } else {

           if {$DataAcquisitionControlServerHost != $::DataAcquisition::ACQSERVER} {
                set DataAcquisitionControlServerHost  $::DataAcquisition::ACQSERVER
                DataAcquisitionControlClient_Configure
           }
           set rc [catch {DataAcquisitionControlClient__GetOption "$AcqGetOption"} m]
      }

        if {$rc != 0} {
            InsertLog "GET OPTION returned with an error\n$m\n$errorCode\n$errorInfo"
            set rc -1
        } else {
#            InsertLog "GET OPTION returned $m"
             set rc [second $m]
        }

        return $rc

     }

    proc DAQ_DoReset {option} {
        global errorCode errorInfo
        global DataAcquisitionControlServerHost
        variable AcqParameter
        global MIDAS_DataAcquisitionControlServer_Exists

       if {[info exists MIDAS_DataAcquisitionControlServer_Exists] && $MIDAS_DataAcquisitionControlServer_Exists == 1} {

          set rc [catch {interp eval "" ::namespace inscope ::urn:DataAcquisitionControlServer DoReset} m]
       } else {

           if {$DataAcquisitionControlServerHost != $::DataAcquisition::ACQSERVER} {
                set DataAcquisitionControlServerHost  $::DataAcquisition::ACQSERVER
                DataAcquisitionControlClient_Configure
           }
           set rc [catch {DataAcquisitionControlClient__DoReset} m]
      }

        if {$rc != 0} {
            InsertLog "DO RESET returned with an error\n$m\n$errorCode\n$errorInfo"
            set rc -1
        } else {
#            InsertLog "DO RESET returned $m"
             set rc [second $m]
        }

        return $rc

     }

    proc DAQ_DoReset {option} {
        global errorCode errorInfo
        global DataAcquisitionControlServerHost
        global MIDAS_DataAcquisitionControlServer_Exists

       if {[info exists MIDAS_DataAcquisitionControlServer_Exists] && $MIDAS_DataAcquisitionControlServer_Exists == 1} {

          set rc [catch {interp eval "" ::namespace inscope ::urn:DataAcquisitionControlServer DoReset "$AcqParameter"} m]
       } else {

           if {$DataAcquisitionControlServerHost != $::DataAcquisition::ACQSERVER} {
                set DataAcquisitionControlServerHost  $::DataAcquisition::ACQSERVER
                DataAcquisitionControlClient_Configure
           }
           set rc [catch {DataAcquisitionControlClient__DoReset "$AcqParameter"} m]
      }

        if {$rc != 0} {
            InsertLog "DO RESET returned with an error\n$m\n$errorCode\n$errorInfo"
            set rc -1
        } else {
#            InsertLog "DO RESET returned $m"
             set rc [second $m]
        }

        return $rc

     }

    proc DAQ_DoSetUp {option} {
        global errorCode errorInfo
        global DataAcquisitionControlServerHost
        variable AcqParameter
        global MIDAS_DataAcquisitionControlServer_Exists

       if {[info exists MIDAS_DataAcquisitionControlServer_Exists] && $MIDAS_DataAcquisitionControlServer_Exists == 1} {

          set rc [catch {interp eval "" ::namespace inscope ::urn:DataAcquisitionControlServer DoSetUp "$AcqParameter"} m]
       } else {

           if {$DataAcquisitionControlServerHost != $::DataAcquisition::ACQSERVER} {
                set DataAcquisitionControlServerHost  $::DataAcquisition::ACQSERVER
                DataAcquisitionControlClient_Configure
           }
           set rc [catch {DataAcquisitionControlClient__DoSetUp "$AcqParameter"} m]
      }

        if {$rc != 0} {
            InsertLog "DO SETUP returned with an error\n$m\n$errorCode\n$errorInfo"
            set rc -1
        } else {
#            InsertLog "DO SETUP returned $m"
             set rc [second $m]
        }

        return $rc

     }

    proc DAQ_DoStop {option} {
        global errorCode errorInfo
        global DataAcquisitionControlServerHost
        variable AcqParameter
        global MIDAS_DataAcquisitionControlServer_Exists

       if {[info exists MIDAS_DataAcquisitionControlServer_Exists] && $MIDAS_DataAcquisitionControlServer_Exists == 1} {

          set rc [catch {interp eval "" ::namespace inscope ::urn:DataAcquisitionControlServer DoStop "$AcqParameter"} m]
       } else {

           if {$DataAcquisitionControlServerHost != $::DataAcquisition::ACQSERVER} {
                set DataAcquisitionControlServerHost  $::DataAcquisition::ACQSERVER
                DataAcquisitionControlClient_Configure
           }
           set rc [catch {DataAcquisitionControlClient__DoStop "$AcqParameter"} m]
      }

        if {$rc != 0} {
            InsertLog "DO STOP returned with an error\n$m\n$errorCode\n$errorInfo"
            set rc -1
        } else {
#            InsertLog "DO STOP returned $m"
             set rc [second $m]
        }

        return $rc

     }

    proc DAQ_DoGo {option} {
        global errorCode errorInfo
        global DataAcquisitionControlServerHost
        variable AcqParameter
        global MIDAS_DataAcquisitionControlServer_Exists

       if {[info exists MIDAS_DataAcquisitionControlServer_Exists] && $MIDAS_DataAcquisitionControlServer_Exists == 1} {

          set rc [catch {interp eval "" ::namespace inscope ::urn:DataAcquisitionControlServer DoGo "$AcqParameter"} m]
       } else {

           if {$DataAcquisitionControlServerHost != $::DataAcquisition::ACQSERVER} {
                set DataAcquisitionControlServerHost  $::DataAcquisition::ACQSERVER
                DataAcquisitionControlClient_Configure
           }
           set rc [catch {DataAcquisitionControlClient__DoGo "$AcqParameter"} m]
      }

        if {$rc != 0} {
            InsertLog "DO GO returned with an error\n$m\n$errorCode\n$errorInfo"
            set rc -1
        } else {
#            InsertLog "DO GO returned $m"
             set rc [second $m]
        }

        return $rc

     }

    proc DAQ_GetState {} {
        global errorCode errorInfo
        global DataAcquisitionControlServerHost
        variable AcqCode
        variable AcqState
        variable AcqInfo
        global MIDAS_DataAcquisitionControlServer_Exists

       if {[info exists MIDAS_DataAcquisitionControlServer_Exists] && $MIDAS_DataAcquisitionControlServer_Exists == 1} {

          set rc [catch {interp eval "" ::namespace inscope ::urn:DataAcquisitionControlServer Do_GetState} m]
       } else {

           if {$DataAcquisitionControlServerHost != $::DataAcquisition::ACQSERVER} {
                set DataAcquisitionControlServerHost  $::DataAcquisition::ACQSERVER
                DataAcquisitionControlClient_Configure
           }
           set rc [catch {DataAcquisitionControlClient__GetState} m]
      }

        if {$rc != 0} {
            InsertLog "STATE for $::DataAcquisition::ACQSERVER returned with an error\n$m\n$errorCode\n$errorInfo"
            set AcqCode 6
            set AcqState "error"
            set AcqInfo "unknown"
        } else {
             set AcqCode [lindex $m 1]
             set AcqState [lindex $m 2]
             set AcqInfo [lindex $m 3]
#            InsertLog "STATE  returned $::DataAcquisition::ACQSERVER: $AcqState"
             set rc [second $m]
        }

        return $rc

     }




